﻿class com.clubpenguin.games.card.BattleController
{
    var _parent, _mc, _battle0_mc, _battle1_mc, _animFrameCounter, dispatchEvent, __get__mc;
    function BattleController(parent)
    {
        mx.events.EventDispatcher.initialize(this);
        _parent = parent;
        _mc = _parent.battle_mc;
        this.loadBasicBattles();
    } // End of the function
    function get mc()
    {
        return (_mc);
    } // End of the function
    function animate(winseat, name, noTieSfx)
    {
        if (_battle0_mc)
        {
            _battle0_mc.removeMovieClip();
        } // end if
        if (_battle1_mc)
        {
            _battle1_mc.removeMovieClip();
        } // end if
        var _loc4 = name.indexOf("pow") != -1 ? (com.clubpenguin.games.card.BattleController.POWER_ANIM[name]) : (com.clubpenguin.games.card.BattleController.BASIC_ANIM[name]);
        var _loc5 = name.indexOf("pow") != -1 ? ("power") : (name);
        switch (_loc5)
        {
            case "walk":
            case "tie":
            case "ambient":
            {
                _battle0_mc = _mc[name].attachMovie(name, "battle0_mc", 1, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                _battle1_mc = _mc[name].attachMovie(name, "battle1_mc", 2, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                if (name == "tie" && !noTieSfx)
                {
                    var _loc3 = new Sound(_battle0_mc);
                    _loc3.attachSound(name + "_sfx");
                    _loc3.start();
                } // end if
                break;
            } 
            case "f":
            case "s":
            case "w":
            case "power":
            {
                if (winseat == 0)
                {
                    _battle0_mc = _mc[name + "_attack"].attachMovie("attack", "battle0_mc", 1, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                    _battle1_mc = _mc[name + "_react"].attachMovie("react", "battle1_mc", 2, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                }
                else
                {
                    _battle0_mc = _mc[name + "_react"].attachMovie("react", "battle0_mc", 1, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                    _battle1_mc = _mc[name + "_attack"].attachMovie("attack", "battle1_mc", 2, {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
                } // end else if
                if (_loc4.attack_top)
                {
                    _mc[name + "_attack"].swapDepths(_mc.getNextHighestDepth());
                }
                else
                {
                    _mc[name + "_react"].swapDepths(_mc.getNextHighestDepth());
                } // end else if
                break;
            } 
            default:
            {
                com.clubpenguin.util.Debug.log("Error Ninja Animation: " + name, "ERROR");
            } 
        } // End of switch
        _battle0_mc._xscale = -100;
        _battle1_mc._xscale = 100;
        _animFrameCounter = 1;
        _mc.onEnterFrame = com.clubpenguin.util.Delegate.create(this, onBattleEnterFrame, name, _loc4.frames);
        this.senseiClip(0, com.clubpenguin.games.card.GameEngine.instance.mode == com.clubpenguin.games.card.GameEngine.MODE_SEN ? (true) : (false));
        this.senseiClip(1, false);
    } // End of the function
    function setColor(player)
    {
        var _loc2 = player.__get__color();
        var _loc5 = new Color(this["_battle" + player.__get__seat() + "_mc"].body_mc);
        var _loc4 = new Color(this["_battle" + player.__get__seat() + "_mc"].frontArm_mc);
        var _loc6 = new Color(this["_battle" + player.__get__seat() + "_mc"].backArm_mc);
        _loc5.setRGB(_loc2);
        _loc4.setRGB(_loc2);
        _loc6.setRGB(_loc2);
    } // End of the function
    function setBeltColor(player)
    {
        var _loc2 = player.__get__rank();
        var _loc4 = com.clubpenguin.games.card.BattleController.BELT_COLOR[_loc2];
        if (_loc2 == 0)
        {
            this["_battle" + player.__get__seat() + "_mc"].belt_mc._visible = false;
            this["_battle" + player.__get__seat() + "_mc"].beltline_mc._visible = false;
            return;
        } // end if
        var _loc5 = new Color(this["_battle" + player.__get__seat() + "_mc"].belt_mc);
        _loc5.setRGB(_loc4);
    } // End of the function
    function senseiClip(seat, bSensei)
    {
        if (bSensei)
        {
            this["_battle" + seat + "_mc"].belt_mc._visible = false;
            this["_battle" + seat + "_mc"].beltline_mc._visible = false;
        }
        else
        {
            this["_battle" + seat + "_mc"].sensay_mc._visible = false;
            this["_battle" + seat + "_mc"].sensay2_mc._visible = false;
            this["_battle" + seat + "_mc"].sensay_mc2._visible = false;
        } // end else if
    } // End of the function
    function loadPowerBattle(type)
    {
        var _loc2 = "pow_" + type;
        this.initLoader(_loc2 + "_attack");
        this.initLoader(_loc2 + "_react");
        com.clubpenguin.games.card.BattleController.POWER_ANIM[_loc2].loaded = true;
    } // End of the function
    function loadBasicBattles()
    {
        for (var _loc2 in com.clubpenguin.games.card.BattleController.BASIC_ANIM)
        {
            if (com.clubpenguin.games.card.BattleController.BASIC_ANIM[_loc2].dual)
            {
                this.initLoader(_loc2 + "_attack");
                this.initLoader(_loc2 + "_react");
                continue;
            } // end if
            this.initLoader(_loc2);
        } // end of for...in
        for (var _loc2 in com.clubpenguin.games.card.BattleController.POWER_ANIM)
        {
            com.clubpenguin.games.card.BattleController.POWER_ANIM[_loc2].loaded = false;
        } // end of for...in
    } // End of the function
    function initLoader(file)
    {
        var _loc4 = _mc.createEmptyMovieClip(file, _mc.getNextHighestDepth(), {_x: com.clubpenguin.games.card.Layout.POS_CENTER.x, _y: com.clubpenguin.games.card.Layout.POS_CENTER.y});
        var _loc3 = new MovieClipLoader();
        var _loc2 = new Object();
        _loc2.onLoadStart = com.clubpenguin.util.Delegate.create(this, onLoadStart);
        _loc2.onLoadInit = com.clubpenguin.util.Delegate.create(this, onLoadInit, _loc3, _loc2);
        _loc2.onLoadProgress = com.clubpenguin.util.Delegate.create(this, onLoadProgress);
        _loc2.onLoadError = com.clubpenguin.util.Delegate.create(this, onLoadError);
        _loc3.addListener(_loc2);
        _loc3.loadClip(com.clubpenguin.games.card.BattleController.BATTLE_FILE_PATH + file + ".swf", _loc4);
    } // End of the function
    function onLoadStart(target)
    {
    } // End of the function
    function onLoadInit(target, loader, listener)
    {
        loader.removeListener(listener);
        if (--_battlesToLoad == 0)
        {
            this.dispatchEvent({target: this, type: com.clubpenguin.games.card.BattleController.FILE_LOADED});
        } // end if
    } // End of the function
    function onLoadProgress(target, progress, total)
    {
    } // End of the function
    function onLoadError(target, error, httpStatus)
    {
        com.clubpenguin.util.Debug.log("Error Loading: " + target + " | " + error + " | " + httpStatus, "ERROR");
    } // End of the function
    function onBattleEnterFrame(name, frames)
    {
        if (frames == undefined)
        {
            _mc.onEnterFrame = null;
            return;
        } // end if
        if (++_animFrameCounter >= frames)
        {
            this.onBattleDone(name);
        } // end if
    } // End of the function
    function onBattleDone(name)
    {
        for (var _loc2 in _battle0_mc)
        {
            _battle0_mc[_loc2].stop();
        } // end of for...in
        for (var _loc2 in _battle1_mc)
        {
            _battle1_mc[_loc2].stop();
        } // end of for...in
        _mc.onEnterFrame = null;
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.BattleController.BATTLE_DONE, anim: name});
    } // End of the function
    static var BATTLE_FILE_PATH = _global.getCurrentShell().getGameContentPath() + "/card/battles/";
    static var BASIC_ANIM = {ambient: {dual: false, frames: undefined, attack_top: true}, walk: {dual: false, frames: 106, attack_top: true}, tie: {dual: false, frames: 45, attack_top: true}, f: {dual: true, frames: 118, attack_top: true}, s: {dual: true, frames: 100, attack_top: true}, w: {dual: true, frames: 91, attack_top: true}};
    static var POWER_ANIM = {pow_71: {dual: true, frames: 105, attack_top: true}, pow_72: {dual: true, frames: 204, attack_top: false}, pow_73: {dual: true, frames: 190, attack_top: true}, pow_74: {dual: true, frames: 194, attack_top: true}, pow_75: {dual: true, frames: 256, attack_top: true}, pow_76: {dual: true, frames: 186, attack_top: false}, pow_77: {dual: true, frames: 166, attack_top: true}, pow_78: {dual: true, frames: 142, attack_top: true}, pow_79: {dual: true, frames: 264, attack_top: true}, pow_80: {dual: true, frames: 175, attack_top: true}, pow_81: {dual: true, frames: 165, attack_top: true}, pow_82: {dual: true, frames: 240, attack_top: false}, pow_83: {dual: true, frames: 148, attack_top: false}, pow_84: {dual: true, frames: 175, attack_top: true}, pow_85: {dual: true, frames: 250, attack_top: true}, pow_86: {dual: true, frames: 178, attack_top: true}, pow_87: {dual: true, frames: 231, attack_top: false}, pow_88: {dual: true, frames: 222, attack_top: false}, pow_89: {dual: true, frames: 139, attack_top: true}, pow_90: {dual: true, frames: 176, attack_top: true}, pow_91: {dual: true, frames: 295, attack_top: false}, pow_92: {dual: true, frames: 183, attack_top: true}, pow_93: {dual: true, frames: 225, attack_top: false}, pow_94: {dual: true, frames: 292, attack_top: true}, pow_95: {dual: true, frames: 355, attack_top: false}, pow_96: {dual: true, frames: 166, attack_top: false}, pow_97: {dual: true, frames: 223, attack_top: true}, pow_249: {dual: true, frames: 200, attack_top: true}, pow_250: {dual: true, frames: 295, attack_top: true}, pow_251: {dual: true, frames: 205, attack_top: false}, pow_252: {dual: true, frames: 172, attack_top: true}, pow_253: {dual: true, frames: 261, attack_top: false}, pow_254: {dual: true, frames: 173, attack_top: true}, pow_255: {dual: true, frames: 296, attack_top: true}, pow_256: {dual: true, frames: 189, attack_top: true}, pow_257: {dual: true, frames: 233, attack_top: true}, pow_258: {dual: true, frames: 215, attack_top: false}, pow_259: {dual: true, frames: 125, attack_top: true}, pow_260: {dual: true, frames: 225, attack_top: true}, pow_349: {dual: true, frames: 145, attack_top: false}, pow_350: {dual: true, frames: 225, attack_top: true}, pow_351: {dual: true, frames: 294, attack_top: false}, pow_352: {dual: true, frames: 196, attack_top: false}, pow_353: {dual: true, frames: 139, attack_top: true}, pow_354: {dual: true, frames: 222, attack_top: false}, pow_355: {dual: true, frames: 183, attack_top: true}, pow_356: {dual: true, frames: 245, attack_top: false}, pow_357: {dual: true, frames: 190, attack_top: true}, pow_358: {dual: true, frames: 135, attack_top: false}, pow_359: {dual: true, frames: 413, attack_top: true}, pow_360: {dual: true, frames: 230, attack_top: true}, pow_427: {dual: true, frames: 306, attack_top: false}, pow_572: {dual: true, frames: 169, attack_top: true}, pow_573: {dual: true, frames: 280, attack_top: false}, pow_574: {dual: true, frames: 179, attack_top: false}, pow_575: {dual: true, frames: 268, attack_top: true}, pow_576: {dual: true, frames: 171, attack_top: true}, pow_577: {dual: true, frames: 218, attack_top: true}, pow_578: {dual: true, frames: 221, attack_top: true}, pow_579: {dual: true, frames: 198, attack_top: true}, pow_580: {dual: true, frames: 195, attack_top: true}, pow_581: {dual: true, frames: 218, attack_top: true}, pow_582: {dual: true, frames: 275, attack_top: false}, pow_583: {dual: true, frames: 181, attack_top: true}, pow_584: {dual: true, frames: 248, attack_top: false}, pow_585: {dual: true, frames: 235, attack_top: false}, pow_586: {dual: true, frames: 208, attack_top: true}, pow_587: {dual: true, frames: 230, attack_top: true}, pow_588: {dual: true, frames: 249, attack_top: true}, pow_589: {dual: true, frames: 205, attack_top: true}, pow_590: {dual: true, frames: 276, attack_top: true}, pow_591: {dual: true, frames: 180, attack_top: false}, pow_592: {dual: true, frames: 315, attack_top: true}, pow_593: {dual: true, frames: 170, attack_top: true}, pow_594: {dual: true, frames: 256, attack_top: true}, pow_595: {dual: true, frames: 260, attack_top: true}};
    static var BELT_COLOR = [null, 16777215, 16776960, 16737792, 3394560, 13260, 13369344, 6684927, 6697728, 4473924, 4473924];
    static var FILE_LOADED = "onFileLoaded";
    static var BATTLE_DONE = "onBattleDone";
    var _battlesToLoad = 9;
} // End of Class
