﻿class com.clubpenguin.games.card.ClientProxy extends com.clubpenguin.games.card.BaseObject
{
    var gameEngine, roomId, dispatchEvent;
    function ClientProxy(gameEngineRef)
    {
        super();
        gameEngine = gameEngineRef;
        roomId = com.clubpenguin.games.card.ClientProxy.SHELL.getCurrentServerRoomId();
        this.addAirtowerListeners();
        mx.events.EventDispatcher.initialize(this);
    } // End of the function
    function sendGetGameMessage(mode)
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_GET_GAME, [mode], com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
    } // End of the function
    function sendJoinGameMessage()
    {
        var _loc2;
        if (_loc2 == undefined)
        {
            com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, "", com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
        }
        else
        {
            com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, [_loc2], com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
        } // end else if
    } // End of the function
    function sendUpdateGameMessage()
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_UPDATE_GAME, "", com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
    } // End of the function
    function sendGameMoveDealMessage(instr, num)
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, [instr, num], com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
    } // End of the function
    function sendGameMovePickMessage(instr, id)
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, [instr, id], com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
    } // End of the function
    function sendLeaveGameMessage()
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.send(com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_EXTENSION_NAME, com.clubpenguin.games.card.ClientProxy.MESSAGE_LEAVE_GAME, "", com.clubpenguin.games.card.ClientProxy.SERVER_SIDE_MESSAGE_TYPE, roomId);
    } // End of the function
    function handleGetGameMessage(resObj)
    {
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_GET_GAME, maxPlayers: resObj[1], numPlayers: resObj[2]});
    } // End of the function
    function handleJoinGameMessage(resObj)
    {
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, seatID: Number(resObj[1]), nickname: resObj[2], color: resObj[3], rank: resObj[4]});
    } // End of the function
    function handleUpdateGameMessage(resObj)
    {
        resObj.shift();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_UPDATE_GAME, players: resObj});
    } // End of the function
    function handleStartGameMessage(resObj)
    {
        resObj.shift();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_START_GAME, data: resObj});
    } // End of the function
    function handleGameMoveMessage(resObj)
    {
        resObj.shift();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, instr: resObj.shift(), data: resObj});
    } // End of the function
    function handleCloseGameMessage(resObj)
    {
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_CLOSE_GAME, nickname: resObj[1]});
    } // End of the function
    function handleLeaveGameMessage(resObj)
    {
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_LEAVE_GAME, seatID: resObj[1]});
    } // End of the function
    function handleGameOverMessage(resObj)
    {
        resObj.shift();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_OVER, coins: resObj.shift(), winseat: resObj.shift(), ids: resObj});
    } // End of the function
    function handleGameAwardMessage(resObj)
    {
        resObj.shift();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_AWARD, rank: resObj.shift()});
    } // End of the function
    function handleStampInfo(resObj)
    {
        resObj.shift();
        resObj.pop();
        this.dispatchEvent({target: this, type: com.clubpenguin.games.card.ClientProxy.MESSAGE_STAMP_INFO, stampInfo: resObj});
    } // End of the function
    function addAirtowerListeners()
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GET_GAME, handleGetGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, handleJoinGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_LEAVE_GAME, handleLeaveGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_UPDATE_GAME, handleUpdateGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_START_GAME, handleStartGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_CLOSE_GAME, handleCloseGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, handleGameMoveMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_OVER, handleGameOverMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_AWARD, handleGameAwardMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.addListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_STAMP_INFO, handleStampInfo, this);
    } // End of the function
    function removeAirtowerListeners()
    {
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GET_GAME, handleGetGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, handleJoinGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_LEAVE_GAME, handleLeaveGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_UPDATE_GAME, handleUpdateGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_START_GAME, handleStartGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_CLOSE_GAME, handleCloseGameMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, handleGameMoveMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_OVER, handleGameOverMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_AWARD, handleGameAwardMessage, this);
        com.clubpenguin.games.card.ClientProxy.AIRTOWER.removeListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_STAMP_INFO, handleStampInfo, this);
    } // End of the function
    static var CLASS_PACKAGE = "com.clubpenguin.games.card";
    static var CLASS_NAME = "ClientProxy";
    static var MESSAGE_GET_GAME = "gz";
    static var MESSAGE_JOIN_GAME = "jz";
    static var MESSAGE_UPDATE_GAME = "uz";
    static var MESSAGE_START_GAME = "sz";
    static var MESSAGE_GAME_MOVE = "zm";
    static var MESSAGE_CLOSE_GAME = "cz";
    static var MESSAGE_LEAVE_GAME = "lz";
    static var MESSAGE_GAME_OVER = "czo";
    static var MESSAGE_GAME_AWARD = "cza";
    static var MESSAGE_STAMP_INFO = "cjsi";
    static var SERVER_SIDE_EXTENSION_NAME = "z";
    static var SERVER_SIDE_MESSAGE_TYPE = "str";
    static var AIRTOWER = _global.getCurrentAirtower();
    static var INTERFACE = _global.getCurrentInterface();
    static var ENGINE = _global.getCurrentEngine();
    static var SHELL = _global.getCurrentShell();
    var __classPackage = com.clubpenguin.games.card.ClientProxy.CLASS_PACKAGE;
    var __className = com.clubpenguin.games.card.ClientProxy.CLASS_NAME;
} // End of Class
