﻿class com.clubpenguin.games.card.GameEngine extends com.clubpenguin.util.StateMachine
{
    var sequence, clock, battleController, powerController, clientProxy, changeState, myPlayer, bGameOver, oGameAwardData, stampInfoAbort, endOfGameStampObject, mode, playerList, seatMap, opponent, bGameStarted, iRound, getCurrentState, iFirstRoundTweens, bHelpOn, oGameOverData, award, leave_room;
    static var root_mc, instance;
    function GameEngine(gameMovie)
    {
        super();
        root_mc = gameMovie;
        instance = this;
        sequence = new com.clubpenguin.util.Sequence();
        clock = new com.clubpenguin.games.card.Clock(com.clubpenguin.games.card.GameEngine.root_mc.mc_clock);
        clock.addEventListener(com.clubpenguin.games.card.Clock.TIME_UP, com.clubpenguin.util.Delegate.create(this, onTimeOut));
        battleController = new com.clubpenguin.games.card.BattleController(com.clubpenguin.games.card.GameEngine.root_mc);
        battleController.addEventListener(com.clubpenguin.games.card.BattleController.FILE_LOADED, com.clubpenguin.util.Delegate.create(this, onBattleLoaded));
        battleController.addEventListener(com.clubpenguin.games.card.BattleController.BATTLE_DONE, com.clubpenguin.util.Delegate.create(this, onBattleDone));
        powerController = new com.clubpenguin.games.card.PowerController(this, sequence, com.clubpenguin.games.card.GameEngine.root_mc.pows_mc);
        clientProxy = new com.clubpenguin.games.card.ClientProxy(this);
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GET_GAME, com.clubpenguin.util.Delegate.create(this, onGetGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_JOIN_GAME, com.clubpenguin.util.Delegate.create(this, onJoinGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_UPDATE_GAME, com.clubpenguin.util.Delegate.create(this, onUpdateGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_START_GAME, com.clubpenguin.util.Delegate.create(this, onStartGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_MOVE, com.clubpenguin.util.Delegate.create(this, onGameMove));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_CLOSE_GAME, com.clubpenguin.util.Delegate.create(this, onCloseGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_LEAVE_GAME, com.clubpenguin.util.Delegate.create(this, onLeaveGame));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_OVER, com.clubpenguin.util.Delegate.create(this, onGameOver));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_GAME_AWARD, com.clubpenguin.util.Delegate.create(this, onGameAward));
        clientProxy.addEventListener(com.clubpenguin.games.card.ClientProxy.MESSAGE_STAMP_INFO, com.clubpenguin.util.Delegate.create(this, onStampInfoRecieved));
        com.clubpenguin.games.card.GameEngine.root_mc.mc_help.onRollOver = com.clubpenguin.util.Delegate.create(this, onHelp);
        com.clubpenguin.games.card.GameEngine.root_mc.mc_help.onRollOut = com.clubpenguin.games.card.GameEngine.root_mc.mc_help.onReleaseOutside = com.clubpenguin.util.Delegate.create(this, offHelp);
        com.clubpenguin.games.card.GameEngine.root_mc.btn_close.onRelease = com.clubpenguin.util.Delegate.create(this, quitGame);
        this.setupGame();
        this.changeState("stateInit");
    } // End of the function
    function onGetGame(o)
    {
        this.handleEvent("onGetGame", o);
    } // End of the function
    function onJoinGame(o)
    {
        this.handleEvent("onJoinGame", o);
    } // End of the function
    function onUpdateGame(o)
    {
        this.handleEvent("onUpdateGame", o);
    } // End of the function
    function onStartGame(o)
    {
        this.showLoading(false);
        this.changeState("stateServe");
        this.handleEvent("onStartGame", o);
    } // End of the function
    function onGameMove(o)
    {
        if (o.instr == "deal" && o.data[0] != myPlayer.__get__seat())
        {
            this.handleOpponentDeal(o.data);
        }
        else if (o.instr == "pick" && o.data[0] != myPlayer.__get__seat())
        {
            this.handleOpponentPick(o.data);
        }
        else
        {
            this.handleEvent("onGameMove", o);
        } // end else if
    } // End of the function
    function onCloseGame(o)
    {
        bGameOver = true;
        if (!leaveGameCalled)
        {
            var _loc3 = _global.getCurrentShell().getLocalizedString("player_quit_prompt");
            _loc3 = _global.getCurrentShell().replace("%name%", o.nickname, _loc3);
            _global.getCurrentInterface().showPrompt("ok", _loc3);
        } // end if
        this.leaveGame();
    } // End of the function
    function onLeaveGame(o)
    {
        _root.closeGame();
    } // End of the function
    function onGameOver(o)
    {
        this.handleEvent("onGameOver", o);
    } // End of the function
    function onGameAward(o)
    {
        oGameAwardData = {rank: o.rank};
        this.addItem(com.clubpenguin.games.card.GameEngine.AWARD_ITEM[o.rank]);
    } // End of the function
    function onStampInfoRecieved(o)
    {
        _global.clearTimeout(stampInfoAbort);
        var _loc6 = o.stampInfo;
        endOfGameStampObject = new Object();
        endOfGameStampObject.isCardJitsu = true;
        endOfGameStampObject.is_table = false;
        endOfGameStampObject.numberOfGameStamps = parseInt(String(_loc6.pop()));
        endOfGameStampObject.totalNumberOfGameStampsEarned = parseInt(String(_loc6.pop()));
        var _loc5 = new Array();
        var _loc4 = String(_loc6[0]).split("|");
        while (_loc4.length > 0)
        {
            var _loc3 = parseInt(String(_loc4.pop()));
            if (_loc3 && !isNaN(_loc3))
            {
                _loc5.push(_loc3);
            } // end if
        } // end while
        endOfGameStampObject.stampIds = _loc5;
        if (leaveGameCalled)
        {
            this.leaveGame();
        } // end if
    } // End of the function
    function onCardLoad(o)
    {
        this.handleEvent("onCardLoad", o);
    } // End of the function
    function onCardTween(o)
    {
        this.handleEvent("onCardTween", o);
    } // End of the function
    function onCardPick(o)
    {
        this.handleEvent("onCardPick", o);
    } // End of the function
    function onCardFlip(o)
    {
        this.handleEvent("flip", o);
    } // End of the function
    function onBattleLoaded(o)
    {
        this.handleEvent("onBattleLoaded", o);
    } // End of the function
    function onBattleDone(o)
    {
        this.handleEvent("onBattleDone", o);
    } // End of the function
    function onTimeOut(o)
    {
        this.handleEvent("onTimeOut", o);
    } // End of the function
    function onHelp()
    {
        this.handleEvent("onHelp");
    } // End of the function
    function offHelp()
    {
        this.handleEvent("offHelp");
    } // End of the function
    function onAwardLoad()
    {
        this.handleEvent("onAwardLoad");
    } // End of the function
    function onAwardMenuClick(o)
    {
        this.handleEvent("onAwardMenuClick");
    } // End of the function
    function stateInit(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
        }
        else if (sEvent == "onBattleLoaded")
        {
            clientProxy.sendGetGameMessage(mode);
        }
        else if (sEvent == "onGetGame")
        {
            if (utEventData.numPlayers < utEventData.maxPlayers)
            {
                clientProxy.sendJoinGameMessage();
            }
            else
            {
                clientProxy.sendUpdateGameMessage();
            } // end else if
        }
        else if (sEvent == "onJoinGame")
        {
            var _loc3 = new com.clubpenguin.games.card.CardPlayer(utEventData.seatID, utEventData.nickname, com.clubpenguin.games.card.GameEngine.SHELL.getPlayerHexFromId(utEventData.color), utEventData.rank);
            playerList.push(_loc3);
            seatMap[utEventData.seatID] = _loc3;
            myPlayer = _loc3;
        }
        else if (sEvent == "onUpdateGame")
        {
            while (utEventData.players.length > 0)
            {
                var _loc7 = utEventData.players.shift();
                var _loc2 = _loc7.split("|");
                var _loc5 = _loc2[0];
                var _loc4 = _loc2[1];
                var _loc9 = _loc2[2];
                var _loc8 = _loc2[3];
                if (!this.isPlayerPresent(_loc4))
                {
                    _loc3 = new com.clubpenguin.games.card.CardPlayer(_loc5, _loc4, com.clubpenguin.games.card.GameEngine.SHELL.getPlayerHexFromId(_loc9), _loc8);
                    playerList.push(_loc3);
                    seatMap[_loc5] = _loc3;
                    if (opponent == null)
                    {
                        opponent = _loc3;
                    } // end if
                } // end if
            } // end while
            this.updatePlayerName();
        }
        else if (sEvent == "leave")
        {
        } // end else if
    } // End of the function
    function stateServe(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
            bGameStarted = true;
            ++iRound;
            if (iRound > 1)
            {
                clientProxy.sendGameMoveDealMessage("deal", 1);
            } // end if
        }
        else if (sEvent == "onStartGame")
        {
            this.ninjaAnimate("walk");
        }
        else if (sEvent == "onBattleDone")
        {
            this.ninjaAnimate("ambient");
            clientProxy.sendGameMoveDealMessage("deal", 5);
        }
        else if (sEvent == "onGameMove")
        {
            switch (utEventData.instr)
            {
                case "deal":
                {
                    var _loc8 = utEventData.data.shift();
                    var _loc2 = utEventData.data;
                    for (var _loc9 = 0; _loc9 < _loc2.length; ++_loc9)
                    {
                        myPlayer.receiveCard(_loc2[_loc9]);
                    } // end of for
                    for (var _loc9 = 0; _loc9 < _loc2.length; ++_loc9)
                    {
                        var _loc3 = _loc2[_loc9].substring(0, _loc2[_loc9].indexOf("|"));
                        var _loc6 = myPlayer.findCardByIdFrom(_loc3, myPlayer.__get__dealts());
                        _loc6.createGraphic(com.clubpenguin.games.card.GameEngine.root_mc.cards_mc, myPlayer.__get__seat(), true);
                        _loc6.addEventListener(com.clubpenguin.games.card.Card.CARD_LOADED, com.clubpenguin.util.Delegate.create(this, onCardLoad));
                        if (com.clubpenguin.games.card.BattleController.POWER_ANIM["pow_" + _loc6.__get__type()] != null && com.clubpenguin.games.card.BattleController.POWER_ANIM["pow_" + _loc6.__get__type()].loaded == false)
                        {
                            battleController.loadPowerBattle(_loc6.__get__type());
                        } // end if
                    } // end of for
                    if (!_loc2.length)
                    {
                        this.changeState("stateInput");
                    } // end if
                    break;
                } 
                default:
                {
                    this.log("WARNING - Unhandeled onGameMove instruction: " + this.getCurrentState() + "[" + utEventData.instr + "]");
                    break;
                } 
            } // End of switch
        }
        else if (sEvent == "onCardLoad")
        {
            _loc6 = utEventData.target;
            sequence.addFunction({i: _loc6, f: "tweenToDealtSlots", p: [myPlayer.__get__seat(), myPlayer.__get__dealtSlots(), com.clubpenguin.games.card.Layout.POS_DEALTS[myPlayer.__get__seat()]]});
            _loc6.removeEventListener(com.clubpenguin.games.card.Card.CARD_LOADED, this);
            _loc6.addEventListener(com.clubpenguin.games.card.Card.CARD_TWEENED, com.clubpenguin.util.Delegate.create(this, onCardTween));
        }
        else if (sEvent == "onCardTween")
        {
            _loc6 = utEventData.target;
            _loc6.removeEventListener(com.clubpenguin.games.card.Card.CARD_TWEENED, this);
            _loc6.addEventListener(com.clubpenguin.games.card.Card.CARD_PICKED, com.clubpenguin.util.Delegate.create(this, onCardPick));
            _loc6.addEventListener(com.clubpenguin.games.card.Card.CARD_FLIPPED, com.clubpenguin.util.Delegate.create(this, onCardFlip));
            if (iRound == 1 && ++iFirstRoundTweens < 5)
            {
                return;
            } // end if
            this.changeState("stateInput");
        }
        else if (sEvent == "leave")
        {
        } // end else if
    } // End of the function
    function stateInput(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
            myPlayer.lockDealts(false);
            var _loc4 = powerController.queryD();
            if (_loc4.receiver == myPlayer.__get__seat())
            {
                if (_loc4.pow == 13)
                {
                    myPlayer.lockAtrCards("s");
                }
                else if (_loc4.pow == 14)
                {
                    myPlayer.lockAtrCards("f");
                }
                else if (_loc4.pow == 15)
                {
                    myPlayer.lockAtrCards("w");
                } // end else if
            } // end else if
            this.startTimeOut();
        }
        else if (sEvent == "onCardPick")
        {
            clock.end();
            myPlayer.pickCard(utEventData.id);
            clientProxy.sendGameMovePickMessage("pick", utEventData.id);
        }
        else if (sEvent == "onTimeOut")
        {
            for (var _loc10 = 0; _loc10 < myPlayer.__get__dealts().length; ++_loc10)
            {
                if (!myPlayer.__get__dealts()[_loc10].lock)
                {
                    myPlayer.__get__dealts()[_loc10].onPick();
                    return;
                } // end if
            } // end of for
            this.log("[ERROR] - NO AVAILABLE CARDS FOR PICK UP - myPlayer.dealts: " + myPlayer.__get__dealts());
            clientProxy.sendGameMovePickMessage("death", opponent.__get__seat());
            this.changeState("stateJudge");
        }
        else if (sEvent == "onGameMove")
        {
            switch (utEventData.instr)
            {
                case "pick":
                {
                    var _loc5 = utEventData.data.shift();
                    var _loc7 = utEventData.data.shift();
                    if (myPlayer.__get__seat() == _loc5)
                    {
                        myPlayer.__get__pick().setState("front", com.clubpenguin.games.card.Layout.SCALE_CARD_FLIP);
                        myPlayer.__get__pick().tweenTo(com.clubpenguin.games.card.Layout.POS_PICKS[_loc5].x, com.clubpenguin.games.card.Layout.POS_PICKS[_loc5].y, 0.500000);
                        this.changeState("stateJudge");
                    } // end if
                    break;
                } 
                default:
                {
                    this.log("WARNING - Unhandeled onGameMove instruction: " + this.getCurrentState() + "[" + utEventData.instr + "]");
                    break;
                } 
            } // End of switch
        }
        else if (sEvent == "onHelp")
        {
            if (bHelpOn === false)
            {
                com.clubpenguin.games.card.GameEngine.root_mc.mc_help.gotoAndPlay("down");
                com.clubpenguin.games.card.GameEngine.root_mc.mc_help.mc_menu.tf_help.text = com.clubpenguin.util.LocaleText.getText("help");
                bHelpOn = undefined;
                var _loc6 = new com.clubpenguin.util.Sequence();
                _loc6.addDelay(500);
                _loc6.addFunction({i: this, f: "setHelpStatus", p: [true]});
            } // end if
        }
        else if (sEvent == "offHelp")
        {
            if (bHelpOn === true)
            {
                com.clubpenguin.games.card.GameEngine.root_mc.mc_help.gotoAndPlay("up");
                bHelpOn = undefined;
                _loc6 = new com.clubpenguin.util.Sequence();
                _loc6.addDelay(500);
                _loc6.addFunction({i: this, f: "setHelpStatus", p: [false]});
            } // end if
        }
        else if (sEvent == "onGameOver")
        {
            bGameOver = true;
            oGameOverData = {winseat: utEventData.winseat, ids: utEventData.ids};
            if (utEventData.ids.length == 0)
            {
                sequence.addFunction({i: this, f: "changeState", p: ["stateOver"]});
            } // end if
        }
        else if (sEvent == "leave")
        {
            com.clubpenguin.games.card.GameEngine.root_mc.mc_help.gotoAndPlay("zero");
            bHelpOn = false;
        } // end else if
    } // End of the function
    function stateJudge(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
        }
        else if (sEvent == "onGameMove")
        {
            switch (utEventData.instr)
            {
                case "judge":
                {
                    var _loc3 = utEventData.data.shift();
                    var _loc12 = utEventData.data.shift();
                    var _loc5 = seatMap[_loc3].pick;
                    sequence.addDelay(1000);
                    sequence.addFunction({i: opponent.__get__pick(), f: "flip", p: [0.250000]});
                    sequence.addDelay(500);
                    powerController.doPowPreJudge();
                    if (_loc3 == -1)
                    {
                        sequence.addFunction({i: myPlayer, f: "cardLose", p: [""]});
                        sequence.addFunction({i: opponent, f: "cardLose", p: [""]});
                        powerController.doPowPostJudge();
                        sequence.addFunction({i: this, f: "ninjaBattle", p: [_loc5, _loc3]});
                    }
                    else if (_loc3 == myPlayer.__get__seat())
                    {
                        sequence.addFunction({i: myPlayer, f: "cardWin", p: [""]});
                        sequence.addFunction({i: opponent, f: "cardLose", p: [""]});
                        powerController.doPowPostJudge();
                        sequence.addFunction({i: myPlayer, f: "arrangeWinCards", p: []});
                        sequence.addFunction({i: this, f: "ninjaBattle", p: [_loc5, _loc3]});
                    }
                    else
                    {
                        sequence.addFunction({i: myPlayer, f: "cardLose", p: [""]});
                        sequence.addFunction({i: opponent, f: "cardWin", p: [""]});
                        powerController.doPowPostJudge();
                        sequence.addFunction({i: opponent, f: "arrangeWinCards", p: []});
                        sequence.addFunction({i: this, f: "ninjaBattle", p: [_loc5, _loc3]});
                    } // end else if
                    break;
                } 
                case "power":
                {
                    var _loc10 = Number(utEventData.data.shift());
                    var _loc15 = Number(utEventData.data.shift());
                    var _loc8 = Number(utEventData.data.shift());
                    var _loc7 = utEventData.data;
                    var _loc6;
                    switch (_loc8)
                    {
                        case 1:
                        case 2:
                        case 3:
                        {
                            _loc6 = {owner: _loc10, receiver: _loc15, pow: _loc8, round: iRound + 1};
                            break;
                        } 
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                        case 9:
                        case 10:
                        case 11:
                        case 12:
                        case 19:
                        case 20:
                        case 21:
                        case 22:
                        case 23:
                        case 24:
                        {
                            _loc6 = {owner: _loc10, receiver: _loc15, pow: _loc8, rems: _loc7, round: iRound};
                            break;
                        } 
                        case 13:
                        case 14:
                        case 15:
                        {
                            _loc6 = {owner: _loc10, receiver: _loc15, pow: _loc8, round: iRound + 1};
                            break;
                        } 
                        case 16:
                        case 17:
                        case 18:
                        {
                            _loc6 = {owner: _loc10, receiver: _loc15, pow: _loc8, round: iRound};
                            break;
                        } 
                        default:
                        {
                            this.log("UNRECGONIZED POWER CARD - power: " + _loc8, "ERROR");
                        } 
                    } // End of switch
                    powerController.addPow(_loc6);
                    break;
                } 
                case "power1":
                {
                    _loc10 = Number(utEventData.data.shift());
                    _loc15 = Number(utEventData.data.shift());
                    _loc8 = Number(utEventData.data.shift());
                    _loc6 = {owner: _loc10, receiver: _loc15, pow: _loc8, round: iRound};
                    powerController.updatePostA(_loc6);
                    break;
                } 
                default:
                {
                    this.log("WARNING - Unhandeled onGameMove instruction: " + this.getCurrentState() + "[" + utEventData.instr + "]");
                    break;
                } 
            } // End of switch
        }
        else if (sEvent == "flip")
        {
        }
        else if (sEvent == "onBattleDone")
        {
            this.ninjaAnimate("ambient");
            if (oGameOverData != null)
            {
                sequence.addFunction({i: this, f: "changeState", p: ["stateOver"]});
            }
            else
            {
                sequence.addFunction({i: this, f: "changeState", p: ["stateServe"]});
            } // end else if
        }
        else if (sEvent == "onGameOver")
        {
            bGameOver = true;
            oGameOverData = {winseat: utEventData.winseat, ids: utEventData.ids};
            if (utEventData.ids.length == 0)
            {
                sequence.addFunction({i: this, f: "changeState", p: ["stateOver"]});
            } // end if
        }
        else if (sEvent == "leave")
        {
        } // end else if
    } // End of the function
    function stateOver(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
            com.clubpenguin.games.card.GameEngine.SHELL.stopGameMusic();
            com.clubpenguin.games.card.GameEngine.root_mc.createEmptyMovieClip("soundInstance", com.clubpenguin.games.card.GameEngine.root_mc.getNextHighestDepth());
            var _loc2 = new Sound(com.clubpenguin.games.card.GameEngine.root_mc.soundInstance);
            _loc2.attachSound("end_sfx");
            _loc2.start();
            if (oGameOverData.ids.length != 0)
            {
                sequence.addFunction({i: seatMap[oGameOverData.winseat], f: "showWinCards", p: [oGameOverData.winseat, oGameOverData.ids]});
                sequence.addDelay(1000);
            }
            else
            {
                oGameOverData.winseat == myPlayer.__get__seat() ? (myPlayer.__get__pick().terminate()) : (opponent.__get__pick().terminate());
            } // end else if
            sequence.addFunction({i: this, f: "ninjaAnimate", p: ["tie", null, true]});
            sequence.addDelay(2500);
            if (oGameOverData.ids.length != 0)
            {
                var _loc3 = (oGameOverData.winseat == myPlayer.__get__seat() ? (myPlayer.__get__nickname()) : (opponent.__get__nickname())) + " " + com.clubpenguin.util.LocaleText.getText("win");
            }
            else
            {
                _loc3 = com.clubpenguin.util.LocaleText.getTextReplaced("sudden_death", [oGameOverData.winseat == myPlayer.__get__seat() ? (opponent.__get__nickname()) : (myPlayer.__get__nickname())]) + ", \n" + (oGameOverData.winseat == myPlayer.__get__seat() ? (myPlayer.__get__nickname()) : (opponent.__get__nickname())) + " " + com.clubpenguin.util.LocaleText.getText("win");
            } // end else if
            sequence.addFunction({i: com.clubpenguin.games.card.GameEngine.INTERFACE, f: "showPrompt", p: ["ok", _loc3, undefined, com.clubpenguin.util.Delegate.create(this, leaveGame)]});
        }
        else if (sEvent == "leave")
        {
        } // end else if
    } // End of the function
    function stateAward(sEvent, utEventData)
    {
        if (sEvent == "enter")
        {
            this.showLoading(true);
            var _loc5 = com.clubpenguin.games.card.GameEngine.root_mc.createEmptyMovieClip("mc_award", com.clubpenguin.games.card.GameEngine.root_mc.getNextHighestDepth());
            var _loc2 = new MovieClipLoader();
            var _loc3 = new Object();
            _loc3.onLoadInit = com.clubpenguin.util.Delegate.create(this, onAwardLoad);
            _loc2.addListener(_loc3);
            _loc2.loadClip(com.clubpenguin.games.card.GameEngine.AWARD_FILE, _loc5);
        }
        else if (sEvent == "onAwardLoad")
        {
            this.showLoading(false);
            award = new com.clubpenguin.games.card.AwardMenu(this, com.clubpenguin.games.card.GameEngine.root_mc.mc_award.menus);
            if (oGameAwardData.rank < 10)
            {
                award.__set__beltID(com.clubpenguin.games.card.AwardMenu.BELTS[oGameAwardData.rank]);
                award.loadMenu(com.clubpenguin.games.card.AwardMenu.MENU_BELT_AWARD);
            }
            else if (oGameAwardData.rank == 10)
            {
                award.loadMenu(com.clubpenguin.games.card.AwardMenu.MENU_FINAL_AWARD);
            }
            else
            {
                com.clubpenguin.util.Debug.log("Wrong Award Data - rank: " + oGameAwardData.rank, "ERROR");
            } // end else if
        }
        else if (sEvent == "onAwardMenuClick")
        {
            award.handleClick(utEventData.click);
        }
        else if (sEvent == "leave")
        {
        } // end else if
    } // End of the function
    function handleEvent(sEvent, utEventData)
    {
        this[this.getCurrentState()](sEvent, utEventData);
    } // End of the function
    function handleOpponentDeal(o)
    {
        var _loc9 = o.shift();
        var _loc3 = o;
        for (var _loc6 = 0; _loc6 < _loc3.length; ++_loc6)
        {
            opponent.receiveCard(_loc3[_loc6]);
        } // end of for
        for (var _loc6 = 0; _loc6 < _loc3.length; ++_loc6)
        {
            var _loc4 = _loc3[_loc6].substring(0, _loc3[_loc6].indexOf("|"));
            var _loc2 = opponent.findCardByIdFrom(_loc4, opponent.__get__dealts());
            _loc2.createGraphic(com.clubpenguin.games.card.GameEngine.root_mc.cards_mc, opponent.__get__seat(), false);
            sequence.addFunction({i: _loc2, f: "tweenToDealtSlots", p: [opponent.__get__seat(), opponent.__get__dealtSlots(), com.clubpenguin.games.card.Layout.POS_DEALTS[opponent.__get__seat()]]});
            _loc2.addEventListener(com.clubpenguin.games.card.Card.CARD_FLIPPED, com.clubpenguin.util.Delegate.create(this, onCardFlip));
            if (com.clubpenguin.games.card.BattleController.POWER_ANIM["pow_" + _loc2.type] != null && com.clubpenguin.games.card.BattleController.POWER_ANIM["pow_" + _loc2.type].loaded == false)
            {
                battleController.loadPowerBattle(_loc2.type);
            } // end if
        } // end of for
    } // End of the function
    function handleOpponentPick(o)
    {
        var _loc2 = o.shift();
        var _loc3 = o.shift();
        opponent.pickCard(_loc3);
        opponent.__get__pick().setState("back", com.clubpenguin.games.card.Layout.SCALE_CARD_FLIP);
        opponent.__get__pick().tweenTo(com.clubpenguin.games.card.Layout.POS_PICKS[_loc2].x, com.clubpenguin.games.card.Layout.POS_PICKS[_loc2].y, 0.500000);
        opponent.__get__pick().addEventListener(com.clubpenguin.games.card.Card.CARD_FLIPPED, com.clubpenguin.util.Delegate.create(this, onCardFlip));
    } // End of the function
    function ninjaAnimate(name, seat, noTieSfx)
    {
        battleController.animate(seat, name, noTieSfx);
        battleController.setColor(myPlayer);
        battleController.setBeltColor(myPlayer);
        battleController.setColor(opponent);
        battleController.setBeltColor(opponent);
    } // End of the function
    function ninjaBattle(win, seat)
    {
        if (win == undefined)
        {
            this.ninjaAnimate("tie");
        }
        else if (win.__get__pow() != 0)
        {
            this.ninjaAnimate("pow_" + win.__get__type(), seat);
        }
        else if (win.__get__pow() == 0)
        {
            this.ninjaAnimate(win.__get__atr(), seat);
        }
        else
        {
            com.clubpenguin.util.Debug.log("Unknown Ninja Battle", "ERROR");
        } // end else if
    } // End of the function
    function startTimeOut()
    {
        clock.start();
    } // End of the function
    function setupGame()
    {
        playerList = new Array();
        seatMap = new Array();
        myPlayer = null;
        opponent = null;
        iRound = 0;
        iFirstRoundTweens = 0;
        bGameStarted = false;
        bGameOver = false;
        bHelpOn = false;
        oGameOverData = null;
        oGameAwardData = null;
        mode = com.clubpenguin.games.card.GameEngine.SHELL.getCookie(com.clubpenguin.games.card.GameEngine.SHELL.GAME_COOKIE, "game_ninja").mode;
        leave_room = com.clubpenguin.games.card.GameEngine.SHELL.getCookie(com.clubpenguin.games.card.GameEngine.SHELL.GAME_COOKIE, "game_ninja").room;
    } // End of the function
    function quitGame()
    {
        if (!bGameStarted)
        {
            this.leaveGame();
        }
        else
        {
            var _loc3 = _global.getCurrentShell().getLocalizedString("quit_game_prompt");
            _global.getCurrentInterface().showPrompt("question", _loc3, undefined, com.clubpenguin.util.Delegate.create(this, leaveGame));
        } // end else if
    } // End of the function
    function leaveGame()
    {
        if (endOfGameStampObject)
        {
            clientProxy.removeAirtowerListeners();
        } // end if
        clock.terminate();
        if (oGameAwardData != null && !leaveGameCalled)
        {
            this.changeState("stateAward");
        }
        else if (endOfGameStampObject)
        {
            sequence.cancel();
            if (endOfGameStampObject.stampIds.length > 0)
            {
                com.clubpenguin.games.card.GameEngine.INTERFACE.showEndGameScreen(endOfGameStampObject, null, leave_room, true);
            }
            else
            {
                com.clubpenguin.games.card.GameEngine.SHELL.sendJoinRoom(leave_room, 0, 0);
            } // end else if
        }
        else
        {
            stampInfoAbort = _global.setTimeout(abortStampInfoRequest, 3000);
            clientProxy.sendLeaveGameMessage();
        } // end else if
        leaveGameCalled = true;
    } // End of the function
    function abortStampInfoRequest()
    {
        endOfGameStampObject = new Object();
        endOfGameStampObject.stampIds = new Array();
        this.leaveGame();
    } // End of the function
    function isPlayerPresent(nickname)
    {
        for (var _loc2 = 0; _loc2 < playerList.length; ++_loc2)
        {
            if (playerList[_loc2].nickname == nickname)
            {
                this.log(nickname + " is already presented...");
                return (true);
            } // end if
        } // end of for
        return (false);
    } // End of the function
    function updatePlayerName()
    {
        for (var _loc2 = 0; _loc2 < seatMap.length; ++_loc2)
        {
            com.clubpenguin.games.card.GameEngine.root_mc["tf_name" + _loc2].text = seatMap[_loc2].nickname.toUpperCase();
        } // end of for
    } // End of the function
    function updateMessage(msg)
    {
        com.clubpenguin.games.card.GameEngine.root_mc.tf_msg.text = msg;
    } // End of the function
    function setHelpStatus(status)
    {
        bHelpOn = status;
    } // End of the function
    function addItem(item_id)
    {
        var _loc2 = com.clubpenguin.games.card.GameEngine.SHELL.getInventoryObjectById(item_id);
        var _loc1 = com.clubpenguin.games.card.GameEngine.SHELL.getMyInventoryArray();
        if (!com.clubpenguin.games.card.GameEngine.SHELL.isItemInMyInventory(item_id))
        {
            _loc1.push(_loc2);
        } // end if
    } // End of the function
    function showLoading(show)
    {
        com.clubpenguin.games.card.GameEngine.root_mc.loading_mc._visible = show ? (true) : (false);
    } // End of the function
    function log(msg)
    {
        com.clubpenguin.util.Debug.log(msg, myPlayer.__get__nickname());
    } // End of the function
    function debugGame()
    {
        this.log("##########################DEBUG GAME##########################");
        this.log("Player List:");
        for (var _loc2 = 0; _loc2 < playerList.length; ++_loc2)
        {
            this.log("--->" + playerList[_loc2]);
        } // end of for
        this.log("Seat Map:");
        for (var _loc2 = 0; _loc2 < seatMap.length; ++_loc2)
        {
            this.log(_loc2 + "--->" + seatMap[_loc2]);
        } // end of for
        this.log("myPlayer: " + myPlayer);
        this.log("opponent: " + opponent);
        this.log("###############################################################");
    } // End of the function
    static var CLASS_PACKAGE = "com.clubpenguin.games.card";
    static var CLASS_NAME = "GameEngine";
    static var AIRTOWER = _global.getCurrentAirtower();
    static var INTERFACE = _global.getCurrentInterface();
    static var ENGINE = _global.getCurrentEngine();
    static var SHELL = _global.getCurrentShell();
    static var MODE_FRD = 1;
    static var MODE_EXP = 2;
    static var MODE_SEN = 3;
    static var AWARD_FILE = _global.getCurrentShell().getGameContentPath() + "/card/award/award.swf";
    static var AWARD_ITEM = [null, 4025, 4026, 4027, 4028, 4029, 4030, 4031, 4032, 4033, 104];
    var __classPackage = com.clubpenguin.games.card.GameEngine.CLASS_PACKAGE;
    var __className = com.clubpenguin.games.card.GameEngine.CLASS_NAME;
    var leaveGameCalled = false;
} // End of Class
