﻿class com.clubpenguin.games.card.PowerController
{
    var _gameEngine, _seq, _mc, _aPows, _topSlots, _pickSlots, __get__sequence;
    function PowerController(engine, sequence, mc)
    {
        _gameEngine = engine;
        _seq = sequence;
        _mc = mc;
        _aPows = new Array();
        _topSlots = [[], [], []];
        _pickSlots = [[], []];
    } // End of the function
    function get sequence()
    {
        return (_seq);
    } // End of the function
    function addPow(pow)
    {
        _aPows.push(pow);
    } // End of the function
    function doPowPreJudge()
    {
        _seq.addFunction({i: this, f: "removeUsedTypeD", p: []});
        this.doPreA();
        this.doE();
        this.doPostB();
        this.doPostA();
        _seq.addDelay(1000);
        _seq.addFunction({i: this, f: "gcPowers", p: []});
    } // End of the function
    function doPowPostJudge()
    {
        this.doC();
        this.doPreB();
        this.doD();
    } // End of the function
    function updatePostA(updateData)
    {
        for (var _loc3 = 0; _loc3 < _aPows.length; ++_loc3)
        {
            var _loc2 = _aPows[_loc3];
            if (updateData.owner == _loc2.owner && updateData.pow == _loc2.pow && updateData.round == _loc2.round)
            {
                _loc2.receiver = updateData.receiver;
                return;
            } // end if
        } // end of for
        com.clubpenguin.util.Debug.log("[updatePostA - NOT FOUND] owner: " + updateData.owner + " | pow: " + updateData.pow + " | round: " + updateData.round, "ERROR");
    } // End of the function
    function queryD()
    {
        for (var _loc3 = 0; _loc3 < _aPows.length; ++_loc3)
        {
            var _loc2 = _aPows[_loc3];
            if (_loc2.pow >= 13 && _loc2.pow <= 15 && _gameEngine.iRound == _loc2.round)
            {
                return (_loc2);
            } // end if
        } // end of for
    } // End of the function
    function doPreA()
    {
        var _loc3 = 0;
        for (var _loc6 = _aPows.length - 1; _loc6 >= 0; --_loc6)
        {
            var _loc2 = _aPows[_loc6];
            if (_loc2.pow == 1 && _gameEngine.iRound < _loc2.round)
            {
                ++_loc3;
                if (_loc3 < 2)
                {
                    _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                    _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "top", seat: 2}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                    _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                    _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.owner}]});
                    _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "top", seat: 2}]});
                    continue;
                } // end if
                _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "movePowerToLastPos", p: [_loc2, {name: "top", seat: 2}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                _seq.addFunction({i: this, f: "removePower", p: [_loc2]});
            } // end if
        } // end of for
    } // End of the function
    function doE()
    {
        for (var _loc5 = _aPows.length - 1; _loc5 >= 0; --_loc5)
        {
            var _loc2 = _aPows[_loc5];
            if (_loc2.pow >= 16 && _loc2.pow <= 18)
            {
                _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "pick", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                _loc2.gc = true;
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function doPostB()
    {
        for (var _loc5 = _aPows.length - 1; _loc5 >= 0; --_loc5)
        {
            var _loc2 = _aPows[_loc5];
            if ((_loc2.pow == 2 || _loc2.pow == 3) && _gameEngine.iRound == _loc2.round)
            {
                _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "pick", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                _loc2.gc = true;
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function doPostA()
    {
        for (var _loc5 = _aPows.length - 1; _loc5 >= 0; --_loc5)
        {
            var _loc2 = _aPows[_loc5];
            if (_loc2.pow == 1 && _gameEngine.iRound == _loc2.round)
            {
                if (_loc2.receiver == -1)
                {
                    _seq.addMovie(_loc2.mc, "poof", true);
                    _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                }
                else
                {
                    _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "pick", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                    _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                } // end else if
                _loc2.gc = true;
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "top", seat: 2}]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function doC()
    {
        for (var _loc6 = _aPows.length - 1; _loc6 >= 0; --_loc6)
        {
            var _loc2 = _aPows[_loc6];
            if (_loc2.pow >= 4 && _loc2.pow <= 12 || _loc2.pow >= 19 && _loc2.pow <= 24)
            {
                _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "top", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                for (var _loc3 = 0; _loc3 < _loc2.rems.length; ++_loc3)
                {
                    _seq.addFunction({i: _gameEngine.seatMap[_loc2.receiver], f: "discardWinCard", p: [_loc2.rems[_loc3]]});
                } // end of for
                _seq.addDelay(500);
                _seq.addFunction({i: this, f: "removePower", p: [_loc2]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "top", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function doPreB()
    {
        for (var _loc5 = _aPows.length - 1; _loc5 >= 0; --_loc5)
        {
            var _loc2 = _aPows[_loc5];
            if ((_loc2.pow == 2 || _loc2.pow == 3) && _gameEngine.iRound < _loc2.round)
            {
                _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "top", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "top", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function doD()
    {
        for (var _loc5 = _aPows.length - 1; _loc5 >= 0; --_loc5)
        {
            var _loc2 = _aPows[_loc5];
            if (_loc2.pow >= 13 && _loc2.pow <= 15 && _gameEngine.iRound < _loc2.round)
            {
                _seq.addFunction({i: this, f: "createPower", p: [_loc2, {name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "movePowerTo", p: [_loc2, {name: "top", seat: _loc2.receiver}, com.clubpenguin.games.card.PowerController.MOVE_DURATION]});
                _seq.addDelay(com.clubpenguin.games.card.PowerController.MOVE_DURATION * 1000);
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "pick", seat: _loc2.owner}]});
                _seq.addFunction({i: this, f: "arrangePowSlot", p: [{name: "top", seat: _loc2.receiver}]});
            } // end if
        } // end of for
    } // End of the function
    function createPower(data, dest)
    {
        var _loc4 = _mc.getNextHighestDepth();
        var _loc3 = this.getPowSlot(dest);
        data.mc = _mc.attachMovie("power", "pow_" + _loc4, _loc4, {_x: _loc3.x, _y: _loc3.y});
        data.mc.gotoAndStop(data.pow);
        data.loc = dest;
        this.addPowToSlot(data, dest);
    } // End of the function
    function movePowerTo(data, dest, duration)
    {
        var _loc3 = this.getPowSlot(dest);
        gs.TweenMax.to(data.mc, duration, {_x: _loc3.x, _y: _loc3.y});
        this.removePowFromSlot(data, data.loc);
        data.loc = dest;
        this.addPowToSlot(data, dest);
    } // End of the function
    function movePowerToLastPos(data, dest, duration)
    {
        var _loc3 = this.getLastPowSlot(dest);
        gs.TweenMax.to(data.mc, duration, {_x: _loc3.x, _y: _loc3.y});
        this.removePowFromSlot(data, data.loc);
        data.loc = dest;
        this.addPowToSlot(data, dest);
    } // End of the function
    function removePower(data)
    {
        for (var _loc2 = _aPows.length - 1; _loc2 >= 0; --_loc2)
        {
            if (data == _aPows[_loc2])
            {
                data.mc.removeMovieClip();
                _aPows.splice(_loc2, 1);
                this.removePowFromSlot(data, data.loc);
                this.arrangePowSlot(data.loc);
            } // end if
        } // end of for
    } // End of the function
    function gcPowers()
    {
        for (var _loc2 = _aPows.length - 1; _loc2 >= 0; --_loc2)
        {
            if (_aPows[_loc2].gc == true)
            {
                this.removePower(_aPows[_loc2]);
            } // end if
        } // end of for
    } // End of the function
    function removeUsedTypeD()
    {
        for (var _loc3 = _aPows.length - 1; _loc3 >= 0; --_loc3)
        {
            var _loc2 = _aPows[_loc3];
            if (_loc2.pow >= 13 && _loc2.pow <= 15 && _gameEngine.iRound == _loc2.round)
            {
                this.removePower(_loc2);
            } // end if
        } // end of for
    } // End of the function
    function getPowSlot(dest)
    {
        var _loc4 = this["_" + dest.name + "Slots"][dest.seat].length;
        var _loc3 = new Object();
        _loc3.x = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].x;
        _loc3.y = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].y;
        if (dest.name == "top")
        {
            _loc3.y = _loc3.y + com.clubpenguin.games.card.PowerController.POWER_SPACER * _loc4;
        }
        else if (dest.name == "pick")
        {
            _loc3.y = _loc3.y - com.clubpenguin.games.card.PowerController.POWER_SPACER * _loc4;
        } // end else if
        return (_loc3);
    } // End of the function
    function getLastPowSlot(dest)
    {
        var _loc4 = this["_" + dest.name + "Slots"][dest.seat].length;
        if (_loc4 == 0)
        {
            return (null);
        } // end if
        var _loc3 = new Object();
        _loc3.x = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].x;
        _loc3.y = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].y;
        if (dest.name == "top")
        {
            _loc3.y = _loc3.y + com.clubpenguin.games.card.PowerController.POWER_SPACER * (_loc4 - 1);
        }
        else if (dest.name == "pick")
        {
            _loc3.y = _loc3.y - com.clubpenguin.games.card.PowerController.POWER_SPACER * (_loc4 - 1);
        } // end else if
        return (_loc3);
    } // End of the function
    function addPowToSlot(data, dest)
    {
        this["_" + dest.name + "Slots"][dest.seat].push(data);
    } // End of the function
    function removePowFromSlot(data, dest)
    {
        var _loc3 = this["_" + dest.name + "Slots"][dest.seat];
        for (var _loc2 = _loc3.length - 1; _loc2 >= 0; --_loc2)
        {
            if (_loc3[_loc2] == data)
            {
                _loc3.splice(_loc2, 1);
            } // end if
        } // end of for
    } // End of the function
    function arrangePowSlot(dest)
    {
        var _loc6 = this["_" + dest.name + "Slots"][dest.seat];
        var _loc3 = new Object();
        _loc3.x = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].x;
        _loc3.y = com.clubpenguin.games.card.PowerController["POS_POWER_" + dest.name.toUpperCase()][dest.seat].y;
        for (var _loc2 = 0; _loc2 < _loc6.length; ++_loc2)
        {
            var _loc4 = _loc6[_loc2];
            if (dest.name == "top")
            {
                gs.TweenMax.to(_loc4.mc, com.clubpenguin.games.card.PowerController.ARRANGE_DURATION, {_x: _loc3.x, _y: _loc3.y + com.clubpenguin.games.card.PowerController.POWER_SPACER * _loc2});
                continue;
            } // end if
            if (dest.name == "pick")
            {
                gs.TweenMax.to(_loc4.mc, com.clubpenguin.games.card.PowerController.ARRANGE_DURATION, {_x: _loc3.x, _y: _loc3.y - com.clubpenguin.games.card.PowerController.POWER_SPACER * _loc2});
            } // end if
        } // end of for
    } // End of the function
    function debugPows()
    {
        com.clubpenguin.util.Debug.log("**********************debugPows**********************", "PowerController");
        for (var _loc3 = 0; _loc3 < _aPows.length; ++_loc3)
        {
            var _loc2 = _aPows[_loc3];
            var _loc4 = "";
            for (var _loc5 in _loc2)
            {
                _loc4 = _loc4 + (_loc5 + ": " + _loc2[_loc5] + " | ");
            } // end of for...in
            com.clubpenguin.util.Debug.log("_aPows[" + _loc3 + "] - " + _loc4, "PowerController");
        } // end of for
        com.clubpenguin.util.Debug.log("**********************debugPows**********************", "PowerController");
    } // End of the function
    function debugPow(type, data)
    {
        com.clubpenguin.util.Debug.log("[do" + type + "] - pow: " + data.pow + " | owner: " + data.owner + " | receiver: " + data.receiver + " | round: " + data.round + " | rems: " + data.rems, "PowerController");
    } // End of the function
    static var POS_POWER_TOP = [{x: 205, y: 35}, {x: 475, y: 35}, {x: 358, y: 60}];
    static var POS_POWER_PICK = [{x: 250, y: 110}, {x: 450, y: 110}];
    static var POWER_SPACER = 40;
    static var MOVE_DURATION = 1;
    static var ARRANGE_DURATION = 0.250000;
} // End of Class
