﻿class gs.TweenFilterLite extends gs.TweenLite
{
    var _clrsa, _filters, _matrix, target, vars, _cmf, _endMatrix, tweens, startTime, duration, _hst, _subTweens;
    function TweenFilterLite($target, $duration, $vars)
    {
        super($target, $duration, $vars);
        if (gs.TweenLite.version < 7 || gs.TweenLite.version == undefined)
        {
        } // end if
        if ($vars.type != undefined)
        {
        } // end if
    } // End of the function
    static function to($target, $duration, $vars)
    {
        return (new gs.TweenFilterLite($target, $duration, $vars));
    } // End of the function
    static function from($target, $duration, $vars)
    {
        $vars.runBackwards = true;
        return (new gs.TweenFilterLite($target, $duration, $vars));
    } // End of the function
    function initTweenVals($hrp, $reservedProps)
    {
        _clrsa = [];
        _filters = [];
        _matrix = gs.TweenFilterLite._idMatrix.slice();
        $reservedProps = $reservedProps || "";
        $reservedProps = $reservedProps + " blurFilter glowFilter colorMatrixFilter dropShadowFilter bevelFilter ";
        if (typeof(target) == "movieclip" || target instanceof TextField)
        {
            var _loc4;
            var _loc5;
            if (vars.blurFilter != undefined)
            {
                _loc5 = vars.blurFilter;
                this.addFilter("blur", _loc5, flash.filters.BlurFilter, ["blurX", "blurY", "quality"], new flash.filters.BlurFilter(0, 0, _loc5.quality || 2));
            } // end if
            if (vars.glowFilter != undefined)
            {
                _loc5 = vars.glowFilter;
                this.addFilter("glow", _loc5, flash.filters.GlowFilter, ["alpha", "blurX", "blurY", "color", "quality", "strength", "inner", "knockout"], new flash.filters.GlowFilter(16777215, 0, 0, 0, _loc5.strength || 1, _loc5.quality || 2, _loc5.inner, _loc5.knockout));
            } // end if
            if (vars.colorMatrixFilter != undefined)
            {
                _loc5 = vars.colorMatrixFilter;
                var _loc11 = this.addFilter("colorMatrix", _loc5, flash.filters.ColorMatrixFilter, [], new flash.filters.ColorMatrixFilter(_matrix));
                _cmf = _loc11.filter;
                _matrix = _cmf.matrix;
                if (_loc5.matrix != undefined && _loc5.matrix instanceof Array)
                {
                    _endMatrix = _loc5.matrix;
                }
                else
                {
                    if (_loc5.relative == true)
                    {
                        _endMatrix = _matrix.slice();
                    }
                    else
                    {
                        _endMatrix = gs.TweenFilterLite._idMatrix.slice();
                    } // end else if
                    _endMatrix = gs.TweenFilterLite.setBrightness(_endMatrix, _loc5.brightness);
                    _endMatrix = gs.TweenFilterLite.setContrast(_endMatrix, _loc5.contrast);
                    _endMatrix = gs.TweenFilterLite.setHue(_endMatrix, _loc5.hue);
                    _endMatrix = gs.TweenFilterLite.setSaturation(_endMatrix, _loc5.saturation);
                    _endMatrix = gs.TweenFilterLite.setThreshold(_endMatrix, _loc5.threshold);
                    if (!isNaN(_loc5.colorize))
                    {
                        _endMatrix = gs.TweenFilterLite.colorize(_endMatrix, _loc5.colorize, _loc5.amount);
                    }
                    else if (!isNaN(_loc5.color))
                    {
                        _endMatrix = gs.TweenFilterLite.colorize(_endMatrix, _loc5.color, _loc5.amount);
                    } // end else if
                } // end else if
                for (var _loc4 = 0; _loc4 < _endMatrix.length; ++_loc4)
                {
                    if (_matrix[_loc4] != _endMatrix[_loc4] && _matrix[_loc4] != undefined)
                    {
                        tweens.push({o: _matrix, p: _loc4.toString(), s: _matrix[_loc4], c: _endMatrix[_loc4] - _matrix[_loc4]});
                    } // end if
                } // end of for
            } // end if
            if (vars.dropShadowFilter != undefined)
            {
                _loc5 = vars.dropShadowFilter;
                this.addFilter("dropShadow", _loc5, flash.filters.DropShadowFilter, ["alpha", "angle", "blurX", "blurY", "color", "distance", "quality", "strength", "inner", "knockout", "hideObject"], new flash.filters.DropShadowFilter(0, 45, 0, 0, 0, 0, 1, _loc5.quality || 2, _loc5.inner, _loc5.knockout, _loc5.hideObject));
            } // end if
            if (vars.bevelFilter != undefined)
            {
                _loc5 = vars.bevelFilter;
                this.addFilter("bevel", _loc5, flash.filters.BevelFilter, ["angle", "blurX", "blurY", "distance", "highlightAlpha", "highlightColor", "quality", "shadowAlpha", "shadowColor", "strength"], new flash.filters.BevelFilter(0, 0, 16777215, 0.500000, 0, 0.500000, 2, 2, 0, _loc5.quality || 2));
            } // end if
            if (vars.runBackwards == true)
            {
                var _loc3;
                for (var _loc4 = 0; _loc4 < _clrsa.length; ++_loc4)
                {
                    _loc3 = _clrsa[_loc4];
                    _loc3.sr = _loc3.sr + _loc3.cr;
                    _loc3.cr = _loc3.cr * -1;
                    _loc3.sg = _loc3.sg + _loc3.cg;
                    _loc3.cg = _loc3.cg * -1;
                    _loc3.sb = _loc3.sb + _loc3.cb;
                    _loc3.cb = _loc3.cb * -1;
                    _loc3.f[_loc3.p] = _loc3.sr << 16 | _loc3.sg << 8 | _loc3.sb;
                } // end of for
            } // end if
            super.initTweenVals(true, $reservedProps);
        }
        else
        {
            super.initTweenVals($hrp, $reservedProps);
        } // end else if
    } // End of the function
    function addFilter($name, $fv, $filterType, $props, $defaultFilter)
    {
        var _loc5 = {type: $filterType};
        var _loc8 = target.filters;
        var _loc3;
        var _loc2;
        var _loc9;
        var _loc4;
        var _loc7;
        for (var _loc3 = 0; _loc3 < _loc8.length; ++_loc3)
        {
            if (_loc8[_loc3] instanceof $filterType)
            {
                _loc5.filter = _loc8[_loc3];
                break;
            } // end if
        } // end of for
        if (_loc5.filter == undefined)
        {
            _loc5.filter = $defaultFilter;
            _loc8.push(_loc5.filter);
            target.filters = _loc8;
        } // end if
        for (var _loc3 = 0; _loc3 < $props.length; ++_loc3)
        {
            _loc2 = $props[_loc3];
            if ($fv[_loc2] != undefined)
            {
                if (_loc2 == "color" || _loc2 == "highlightColor" || _loc2 == "shadowColor")
                {
                    _loc4 = this.HEXtoRGB(_loc5.filter[_loc2]);
                    _loc7 = this.HEXtoRGB($fv[_loc2]);
                    _clrsa.push({f: _loc5.filter, p: _loc2, sr: _loc4.rb, cr: _loc7.rb - _loc4.rb, sg: _loc4.gb, cg: _loc7.gb - _loc4.gb, sb: _loc4.bb, cb: _loc7.bb - _loc4.bb});
                    continue;
                } // end if
                if (_loc2 == "quality" || _loc2 == "inner" || _loc2 == "knockout" || _loc2 == "hideObject")
                {
                    _loc5.filter[_loc2] = $fv[_loc2];
                    continue;
                } // end if
                if (typeof($fv[_loc2]) == "number")
                {
                    _loc9 = $fv[_loc2] - _loc5.filter[_loc2];
                }
                else
                {
                    _loc9 = Number($fv[_loc2]);
                } // end else if
                tweens.push({o: _loc5.filter, p: _loc2, s: _loc5.filter[_loc2], c: _loc9});
            } // end if
        } // end of for
        _filters.push(_loc5);
        _hf = true;
        return (_loc5);
    } // End of the function
    function render($t)
    {
        var _loc11 = ($t - startTime) / 1000;
        var _loc7;
        var _loc4;
        var _loc3;
        if (_loc11 >= duration)
        {
            _loc11 = duration;
            _loc7 = 1;
        }
        else
        {
            _loc7 = vars.ease(_loc11, 0, 1, duration);
        } // end else if
        for (var _loc3 = tweens.length - 1; _loc3 > -1; --_loc3)
        {
            _loc4 = tweens[_loc3];
            _loc4.o[_loc4.p] = _loc4.s + _loc7 * _loc4.c;
        } // end of for
        if (_hf)
        {
            var _loc5;
            var _loc9;
            var _loc10;
            var _loc8;
            for (var _loc3 = _clrsa.length - 1; _loc3 > -1; --_loc3)
            {
                _loc4 = _clrsa[_loc3];
                _loc9 = _loc4.sr + _loc7 * _loc4.cr;
                _loc10 = _loc4.sg + _loc7 * _loc4.cg;
                _loc8 = _loc4.sb + _loc7 * _loc4.cb;
                _loc4.f[_loc4.p] = _loc9 << 16 | _loc10 << 8 | _loc8;
            } // end of for
            if (_cmf)
            {
                _cmf.matrix = _matrix;
            } // end if
            var _loc6 = target.filters;
            for (var _loc3 = 0; _loc3 < _filters.length; ++_loc3)
            {
                for (var _loc5 = _loc6.length - 1; _loc5 > -1; --_loc5)
                {
                    if (_loc6[_loc5] instanceof _filters[_loc3].type)
                    {
                        _loc6.splice(_loc5, 1, _filters[_loc3].filter);
                        break;
                    } // end if
                } // end of for
            } // end of for
            target.filters = _loc6;
        } // end if
        if (_hst)
        {
            for (var _loc3 = _subTweens.length - 1; _loc3 > -1; --_loc3)
            {
                _subTweens[_loc3].proxy(_subTweens[_loc3]);
            } // end of for
        } // end if
        if (vars.onUpdate != undefined)
        {
            vars.onUpdate.apply(vars.onUpdateScope, vars.onUpdateParams);
        } // end if
        if (_loc11 == duration)
        {
            super.complete(true);
        } // end if
    } // End of the function
    function HEXtoRGB($n)
    {
        return ({rb: $n >> 16, gb: $n >> 8 & 255, bb: $n & 255});
    } // End of the function
    static function colorize($m, $color, $amount)
    {
        if ($color == undefined || isNaN($color))
        {
            return ($m);
        } // end if
        if ($amount == undefined)
        {
            $amount = 1;
        } // end if
        var _loc3 = ($color >> 16 & 255) / 255;
        var _loc5 = ($color >> 8 & 255) / 255;
        var _loc2 = ($color & 255) / 255;
        var _loc4 = 1 - $amount;
        var _loc7 = [_loc4 + $amount * _loc3 * gs.TweenFilterLite._lumR, $amount * _loc3 * gs.TweenFilterLite._lumG, $amount * _loc3 * gs.TweenFilterLite._lumB, 0, 0, $amount * _loc5 * gs.TweenFilterLite._lumR, _loc4 + $amount * _loc5 * gs.TweenFilterLite._lumG, $amount * _loc5 * gs.TweenFilterLite._lumB, 0, 0, $amount * _loc2 * gs.TweenFilterLite._lumR, $amount * _loc2 * gs.TweenFilterLite._lumG, _loc4 + $amount * _loc2 * gs.TweenFilterLite._lumB, 0, 0, 0, 0, 0, 1, 0];
        return (gs.TweenFilterLite.applyMatrix(_loc7, $m));
    } // End of the function
    static function setThreshold($m, $n)
    {
        if ($n == undefined || isNaN($n))
        {
            return ($m);
        } // end if
        var _loc2 = [gs.TweenFilterLite._lumR * 256, gs.TweenFilterLite._lumG * 256, gs.TweenFilterLite._lumB * 256, 0, -256 * $n, gs.TweenFilterLite._lumR * 256, gs.TweenFilterLite._lumG * 256, gs.TweenFilterLite._lumB * 256, 0, -256 * $n, gs.TweenFilterLite._lumR * 256, gs.TweenFilterLite._lumG * 256, gs.TweenFilterLite._lumB * 256, 0, -256 * $n, 0, 0, 0, 1, 0];
        return (gs.TweenFilterLite.applyMatrix(_loc2, $m));
    } // End of the function
    static function setHue($m, $n)
    {
        if ($n == undefined || isNaN($n))
        {
            return ($m);
        } // end if
        $n = $n * 0.017453;
        var _loc1 = Math.cos($n);
        var _loc2 = Math.sin($n);
        var _loc4 = [gs.TweenFilterLite._lumR + _loc1 * (1 - gs.TweenFilterLite._lumR) + _loc2 * -gs.TweenFilterLite._lumR, gs.TweenFilterLite._lumG + _loc1 * -gs.TweenFilterLite._lumG + _loc2 * -gs.TweenFilterLite._lumG, gs.TweenFilterLite._lumB + _loc1 * -gs.TweenFilterLite._lumB + _loc2 * (1 - gs.TweenFilterLite._lumB), 0, 0, gs.TweenFilterLite._lumR + _loc1 * -gs.TweenFilterLite._lumR + _loc2 * 0.143000, gs.TweenFilterLite._lumG + _loc1 * (1 - gs.TweenFilterLite._lumG) + _loc2 * 0.140000, gs.TweenFilterLite._lumB + _loc1 * -gs.TweenFilterLite._lumB + _loc2 * -0.283000, 0, 0, gs.TweenFilterLite._lumR + _loc1 * -gs.TweenFilterLite._lumR + _loc2 * -(1 - gs.TweenFilterLite._lumR), gs.TweenFilterLite._lumG + _loc1 * -gs.TweenFilterLite._lumG + _loc2 * gs.TweenFilterLite._lumG, gs.TweenFilterLite._lumB + _loc1 * (1 - gs.TweenFilterLite._lumB) + _loc2 * gs.TweenFilterLite._lumB, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1];
        return (gs.TweenFilterLite.applyMatrix(_loc4, $m));
    } // End of the function
    static function setBrightness($m, $n)
    {
        if ($n == undefined || isNaN($n))
        {
            return ($m);
        } // end if
        $n = $n * 100 - 100;
        return (gs.TweenFilterLite.applyMatrix([1, 0, 0, 0, $n, 0, 1, 0, 0, $n, 0, 0, 1, 0, $n, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1], $m));
    } // End of the function
    static function setSaturation($m, $n)
    {
        if ($n == undefined || isNaN($n))
        {
            return ($m);
        } // end if
        var _loc4 = 1 - $n;
        var _loc3 = _loc4 * gs.TweenFilterLite._lumR;
        var _loc5 = _loc4 * gs.TweenFilterLite._lumG;
        var _loc2 = _loc4 * gs.TweenFilterLite._lumB;
        var _loc6 = [_loc3 + $n, _loc5, _loc2, 0, 0, _loc3, _loc5 + $n, _loc2, 0, 0, _loc3, _loc5, _loc2 + $n, 0, 0, 0, 0, 0, 1, 0];
        return (gs.TweenFilterLite.applyMatrix(_loc6, $m));
    } // End of the function
    static function setContrast($m, $n)
    {
        if ($n == undefined || isNaN($n))
        {
            return ($m);
        } // end if
        $n = $n + 0.010000;
        var _loc2 = [$n, 0, 0, 0, 128 * (1 - $n), 0, $n, 0, 0, 128 * (1 - $n), 0, 0, $n, 0, 128 * (1 - $n), 0, 0, 0, 1, 0];
        return (gs.TweenFilterLite.applyMatrix(_loc2, $m));
    } // End of the function
    static function applyMatrix($m, $m2)
    {
        if ($m == undefined || !($m instanceof Array) || $m2 == undefined || !($m2 instanceof Array))
        {
            return ($m2);
        } // end if
        var _loc7 = [];
        var _loc2 = 0;
        var _loc5 = 0;
        var _loc6;
        var _loc1;
        for (var _loc6 = 0; _loc6 < 4; ++_loc6)
        {
            for (var _loc1 = 0; _loc1 < 5; ++_loc1)
            {
                if (_loc1 == 4)
                {
                    _loc5 = $m[_loc2 + 4];
                }
                else
                {
                    _loc5 = 0;
                } // end else if
                _loc7[_loc2 + _loc1] = $m[_loc2] * $m2[_loc1] + $m[_loc2 + 1] * $m2[_loc1 + 5] + $m[_loc2 + 2] * $m2[_loc1 + 10] + $m[_loc2 + 3] * $m2[_loc1 + 15] + _loc5;
            } // end of for
            _loc2 = _loc2 + 5;
        } // end of for
        return (_loc7);
    } // End of the function
    static var version = 7.300000;
    static var delayedCall = gs.TweenLite.delayedCall;
    static var killTweensOf = gs.TweenLite.killTweensOf;
    static var killDelayedCallsTo = gs.TweenLite.killDelayedCallsTo;
    static var _idMatrix = [1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0];
    static var _lumR = 0.212671;
    static var _lumG = 0.715160;
    static var _lumB = 0.072169;
    var _hf = false;
} // End of Class
